#!/usr/local/bin/pgoblin -f
  Copyright (C)2019 @BABOLO http://www.babolo.ru/
--PKG = mini-cipa
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: cipafan.pgoblin.m4,v 1.1 2021/03/31 21:38:28 babolo Exp $

#close   1011
#connect 0001
CIPA_DBMS
GETARG(, 1, 1)dnl
#echo    Q
##Q copy E
#style   00Q00Q
Q
#perform 0001
CREATE TEMP TABLE x
     ( b text    --  
     )
;
#select  1001
SELECT 'pgsql dbname='
    || COALESCE(NULLIF('PROTOVER', ''), 'minicipa')
    || ' requirepeer=postgres application_name=minicipa_cipafan'
;
#connect 0102
#close   101
#perform 0002  ##############################################    cipalan   cipafan  ####
DROP VIEW IF EXISTS public.cipafan;
#select  1002
SELECT n
 FROM(SELECT -1 AS o
           , '
       CREATE OR REPLACE VIEW public.cipafan AS
        SELECT cipalan.cipalan
             , cipalan.cipath
             , cipalan.selflock
             , cipalan.cipaown
             , cipalan.period
             , cipalan.strict
             , cipalan.selfgr
             , cipalan.success
             , cipalan.resource
             , cipalan.resar
             , cipalan.renul
'       AS n
       UNION
        SELECT cipares.cipares
             , '       , CASE WHEN public.bytearrmax
'            || '(substring(public.bytearrmask(cipalan.resource, public.num2bit('
             || cipares.cipares::text
             || ')), '
             || (cipares.cipares + 1)::text
             || ')) > 0
'            || '             THEN substring(public.bytearrmask(cipalan.resource, public.num2bit('
             || cipares.cipares::text
             || ')), '
             || (cipares.cipares + 1)::text
             || ')
'            || '        END AS '
             || cipares.ciparesnm
             || '
'        FROM public.cipares
       UNION
        SELECT 999999
             ,  '       , CASE WHEN public.bytearrmax(public.bytearrmask(cipalan.resource, m.m)) > 0
'            || '              THEN public.bytearrmask(cipalan.resource, m.m)
'            || '         END AS tail
        FROM public.cipalan
           , (SELECT ~public.bitex0( public.disjunction(public.num2bit(cipares.cipares))
                                   , MAX(octet_length(cipalan.resource))
                                   )AS m
               FROM public.cipares, public.cipalan
             )m
;
'    )n
 ORDER BY o
;
#echo    21
#perform 0202
#close   202
#perform 0002
GRANT SELECT ON public.cipafan TO public;
#perform 0002
COMMENT ON VIEW public.cipafan           IS '  ';
COMMENT ON COLUMN public.cipafan.cipalan    IS ' ';
COMMENT ON COLUMN public.cipafan.cipath     IS 'PATH  +  ';
COMMENT ON COLUMN public.cipafan.selflock   IS '  (NULL , 0 -   , ...)';
COMMENT ON COLUMN public.cipafan.cipaown    IS '   ';
COMMENT ON COLUMN public.cipafan.period     IS ' ';
COMMENT ON COLUMN public.cipafan.strict     IS '     ';
COMMENT ON COLUMN public.cipafan.selfgr     IS '  ';
COMMENT ON COLUMN public.cipafan.success    IS '  ';
COMMENT ON COLUMN public.cipafan.resource   IS '   ';
COMMENT ON COLUMN public.cipafan.resar      IS '    ';
COMMENT ON COLUMN public.cipafan.renul      IS '   ,   resar';
COMMENT ON COLUMN public.cipafan.tail       IS ' ';
