#!/usr/local/bin/pgoblin -f
  Copyright (C)2019 @BABOLO http://www.babolo.ru/
--PKG = mini-cipa
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: version.pgoblin.m4,v 1.2 2020/09/22 00:56:32 babolo Exp $

#echo    Q
##Q copy E
#style   00Q00Q
Q
#connect 0001
sqlite2 :memory:
#select  2001
SELECT 'pgsql dbname='
    || COALESCE(NULLIF('PROTOVER', ''), 'minicipa')
    || ' requirepeer=postgres application_name=minicipa'
;
#connect 0202
#perform 0001
CREATE TEMP TABLE d(i int, d text);
#perform 0002
CREATE TEMP TABLE v(m text, p text, v text);
#perform 0001
CREATE TEMP TABLE m(m text, p text);
#getdir  1
0x03 /usr/local/include/babolo
#copyin  0011
COPY d;
#close   101
#job     00001
local -Z 1
#perform 0001
DELETE FROM d WHERE NOT regexp('\.VERSION$', d);
#perform 0001
UPDATE d SET d = substr(d, 1, length(d) - 8);
#perform 0001
INSERT INTO m(m) SELECT d FROM d WHERE NOT regexp(':', d);
#perform 0001
DELETE FROM d WHERE d IN(SELECT m FROM m);
#perform 0001
INSERT INTO m(m, p)
 SELECT substr(d, 1, instr(d, ':') - 1)
      , substr(d, instr(d, ':') + 1, length(d))
  FROM d
;
#select  1001
SELECT m, p FROM m;
#perform 0001
CREATE TEMP TABLE e(e text, a text);
#perform 0011
INSERT INTO e
 SELECT '/usr/local/bin/pgoblin'
      , '-e
##echo    Q
###Q copy
##style   00Q00Q
Q
##connect 0001
sqlite2 :memory:
##perform 0001
CREATE TEMP TABLE m(m text, p text);
##perform 0001
CREATE TEMP TABLE v(v text);
##perform 0001
INSERT INTO m(m, p) VALUES(' || quote_literal(?) || ', ' || COALESCE(quote_literal(?), 'NULL') || ');
##select  1001
SELECT ''/bin/cat'', ''/usr/local/include/babolo/'' || m || COALESCE('':'' || p, '''') || ''.VERSION'' FROM m;
##exec    21
##copyin  0021
COPY v
##close   202
##select  1001
SELECT m, p, v FROM m, v;
##display 00100Q
'
;
#select  1001
SELECT * FROM e;
#exec    21001
#copyin  0022
COPY v FROM stdin
#wait    00001
#close   202
#select  1002
SELECT * FROM v;
#perform 0002
CREATE TEMP TABLE s(n text, v int, m text);
#exec    2
/usr/bin/fetch
#
-qo
#
-
#
http://www.b.babolo.ru/src/
#exec    302
/usr/bin/awk
#
/^<tr><td.*td><td><a href="/{
    sub(/^<tr><td.*td><td><a href="/, "")
    sub(/">.*$/, "")
    sub(/\.gz$/, "")
    sub(/\.bz2$/, "")
    sub(/\.tar$/, "")
    if  (/^[-_A-Za-z0-9--ߣ]+-[0-9]+\.[0-9]+[a-z]*$/) {
        a1 = $0
        a2 = $0
        sub(/-[0-9]+\.[0-9]+[a-z]*$/, "", a1)
        sub("^" a1 "-", "", a2)
        b1 = a2
        b2 = a2
        sub(/\.[0-9]+[a-z]*$/, "", b1)
        sub("^" b1 "\.", "", b2)
        print a1 "	" b1 "	" b2
}   }
#copyin 0032
COPY s FROM stdin;
#wait
#close 202
#close 303
#close   202
#perform 0012
UPDATE public.version
   SET (major, minor) = (regexp_replace($3::text, '\..+$', '')::int, regexp_replace($3::text, '^.+\.', ''))
 WHERE (pkg, protover) = ($1::text, $2::text)
   AND (major::text || '.' || minor) <> $3::text
;
#perform 0002
UPDATE public.version
   SET major = regexp_replace(v, '\..+$', '')::int
     , minor = regexp_replace(v, '^.+\.', '')
 FROM v
 WHERE pkg = m
   AND protover IS NULL
   AND p IS NULL
   AND (major::text || '.' || minor::text) <> v
;
#perform 0002
INSERT INTO public.version(pkg, protover, major, minor)
 SELECT m, p, regexp_replace(v, '\..+$', '')::int, regexp_replace(v, '^.+\.', '')
  FROM v
  WHERE (m, p) NOT IN(SELECT pkg, protover FROM public.version)
    AND p IS NOT NULL
;
#perform 0002
INSERT INTO public.version(pkg, major, minor)
 SELECT m, regexp_replace(v, '\..+$', '')::int, regexp_replace(v, '^.+\.', '')
  FROM v
  WHERE m NOT IN(SELECT pkg FROM public.version WHERE protover IS NULL)
    AND p IS NULL
;
#perform 0002
DELETE FROM public.version
 WHERE NOT EXISTS(SELECT 1 FROM v WHERE pkg = m AND protover IS NOT DISTINCT FROM p)
;
#close   101
#select  1002
SELECT n, v, MAX(m) AS m FROM s GROUP BY n, v;
#perform 0012
UPDATE public.srcs
   SET minor = $3::text
 WHERE (pkg, major) = ($1::text, $2::int)
   AND minor <> $3::text
;
#perform 0012
INSERT INTO public.srcs(pkg, major, minor)
 SELECT $1::text, $2::int, $3::text
  WHERE ($1::text, $2::int) NOT IN(SELECT pkg, major FROM public.srcs)
;
#perform 0002
DELETE FROM public.srcs
  WHERE (pkg, major) NOT IN(SELECT n, v FROM s)
;
#
